package MiniSplit::FileSplit;

#
# Copyright 2001, Rab-Duck <rabduck@mail.infoseek.co.jp>
#
# This library is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# 
# Last Update(UTC): $Date: 2001/01/19 16:22:00 $
#

=head1 NAME

MiniSplit::FileSplit - File Splitter Module

=head1 SYNOPSIS

 use MiniSplit::FileSplit;
 $fs = new MiniSplit::FileSplit;

 # ɤϴޤޤʸʸζ̤򤹤
 $fs->set_props(KEYWORD_INC => 0, CASE_SENSITIVE => 1);

 # оݥե ./text.txt 
 $fs->set_file_name("./test.txt");

 # гϰ֤Ƚλ֤ʸ
 #   λ֤λΤ褦ˡɽλǽ
 #   "\n?" ʤɤꤷƤΤϡڤФ̤椹뤿ᡣ
 #   ڤФλ̤ΰ֤ޤǳϰ֤佪λ֤ȸΤǡ
 #   Ԥޤ᤿ʤɤϡΤ褦˻ꤹ롣
 $fs->set_split_text("--- г ---\n", "---[ \t]*нλ[ \t]*---\n?");

 # н(ʸŸ
 $text = $fs->get_file_part(var1 => "ʸ1", var2 => "ʸ2");

=head1 DESCRIPTION

B<MiniSplit::FileSplit> 饹ϡPerl 5 Υ⥸塼ǡ

  ե뤫ʬ

  Ф˴ޤޤʸʬѴ

Ȥǽ󶡤ޤ(ʹߡB<MiniSplit::FileSplit>  B<FileSplit> Ⱦά)

Фγϰ֤Ƚλ֤ϡB<FileSplit> Ѽ¦Ǥդʸꤷޤ

ޤʸˤĤƤϡեǡ

  ${hogehoge}

ȤǻꤷƤB<FileSplit> Ǥлˤβʸ֤ʸꤷޤ

㤨С

    aaa
 
    --- Sep-S ---
    bbb
    This is variable -> ${var}
    ccc
    ddd
    --- Sep-E ---
    eee

Ȥե F<test.txt> 顢bbb  ddd ֤Ф ${var}
Ƥ֤ȤȤޤ

ξˤϡB<FileSplit> Фơ

    $fs = new MiniSplit::FileSplit;

    # ư
    $fs->set_props(KEYWORD_INC => 0);
    $fs->set_file_name("./test.txt");
    $fs->set_split_text("--- Sep-S ---", "--- Sep-E *---\n?");

    # С
    $text = $fs->get_file_part(var => "ʸ" );
    print $text;

ȤȡF<test.txt> 

    bbb
    This is variable -> ʸ
    ccc
    ddd

ȤƤǤޤ

ʸϡ̤̾ΡƱ̾ΤΤɤǤʣսळȤǽǤƱΤʣսˤϡƱͤǤ餬Ÿޤ

Ÿ޻ߤսˤ \${hogehoge} ȥƥǡB<\> ޻ߤս˻ꤷޤ
ܺ٤ϼΤ褦˹Ԥʤޤ

    ${hogehoge}    -> Ÿ
    \${hogehoge}   -> ޻
    \\${hogehoge}  -> \ + Ÿ  (\\  \ Ȥư)
    \\\${hogehoge} -> \ + ޻ (ǽ \\  \,  \ ޻߻Ȥߤʤ)

    $ ޤʤ \ 1ʸ \ Ȥ롣


=head1 Methods


B<FileSplit> ϡΤ褦ʥ᥽åɤޤ

=over 4

=cut


require 'jcode.pl';

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);


$VERSION = '1.00';

my @props = ('CASE_SENSITIVE',	'KEYWORD_INC',
	     'INPUT_CODE',	'INPUT_CONV_OPT',
	     'OUTPUT_CODE',	'OUTPUT_CONV_OPT');


=item $fs = new MiniSplit::FileSplit;

B<FileSplit> ο֥Ȥޤ

ȤơB<set_props()> ؿƱƤϤư򤹤뤳ȤǽǤ


=cut

sub new()
{
    # 饹֥̾ȤλȤ
    my $class = shift;
    my $self = {};

    # bless
    bless($self, $class);
    
    # оݥե̾
    $self->{FNAME} = ""; 

    # оݥƥ
    $self->{TEXT} = ""; 

    # ڤФ(ϡλ)
    $self->{SPLIT_TEXT_S} = ""; 
    $self->{SPLIT_TEXT_E} = ""; 

    # ڤФΥɤʸʸ̤뤫ɤ
    #   0: ʤ
    #   0ʳ: ʥǥեȡ
    $self->{CASE_SENSITIVE} = 1; 

    # лʬޤࡿޤޤʤǽ
    #   0: ޤޤʤ
    #   0ʳ: ޤʥǥեȡ
    $self->{KEYWORD_INC} = 1;

    # ϥ
    #   ǥեȤϡ
    #     ϤϼưȽѤ euc Ѵ
    #     Ϥ euc 
    $self->{INPUT_CODE} = '';
    $self->{OUTPUT_CODE} = 'euc';

    # ϻΥѴΥץ
    $self->{INPUT_CONV_OPT} = '';
    $self->{OUTPUT_CONV_OPT} = '';

    # ե˥å夹롿ʤ(ߤϤʤ
    #   0: ʤ
    #   0ʳ: ʥǥեȡ
    #$self->{FILE_CACHE} = 1;

    # ѥ᡼СԤʤ
    if ($#_ > 0) {
	$self->set_props(@_);
    }

    return $self;
}


=item $fs->set_props($field => $value,...);

B<FileSplit> ưξܺԤʤ֥롼Ǥ

Ǥܤϡ

  CASE_SENSITIVE 
    ڤФΥɤʸʸ̤뤫ο͡
    : (̤)

  KEYWORD_INC 
    лʬޤࡿޤޤʤο͡
    : (ޤ)

  INPUT_CODE 
    ϥեʸɷϡ
    'euc','sjis','jis' Τ줫ǽ(jcode.pl ˰¸)
    : ưȽ (Ѥ euc Ѵ)
            äˡsjis ξˤϡŪ˻ꤹ뤳Ȥ侩

  OUTPUT_CODE
    ϥƥȤʸɷϡ
    'euc','sjis','jis' Τ줫ǽ(jcode.pl ˰¸)
    : euc

  INPUT_CONV_OPT
    ϥեʸѴѥץ
    Ѵ jcode.pl Ϥץ󤬤лꡣ
    :ʤ

  OUTPUT_CONV_OPT (ϥƥȤʸѴѥץ jcode.pl)
    ϥƥȤʸѴѥץ
    Ѵ jcode.pl Ϥץ󤬤лꡣ
    :ʤ

  ѴԥɤϤΤޤޤǤ

ǽǤ

ˤϡꤹ̾Τͤ򡢥ͤΥڥȤꤷϥåѿϤ

    %param = (CASE_SENSITIVE => 1, KEYWORD_INC => 1);
    %param = (CASE_SENSITIVE => 1);

뤤ϡƤӽФľܡ

    $fs->param(CASE_SENSITIVE => 1, KEYWORD_INC => 1);
    $fs->param(CASE_SENSITIVE => 1);

ȤͤϤƲ



=cut

sub set_props(%)
{
    my $self = shift;
    my %arg = @_;
    my $prop;

    # ñ
    foreach $prop (@props) {
	if (defined $arg{$prop}) {
	    $self->{$prop} = $arg{$prop};
	}
    }
    
    return 1;
}

=item $fs->get_props();

B<FileSplit> ưξܺͤ륵֥롼Ǥ

B<set_props> ѥ᡼ˤĤơϥå֤ͤޤ

    %param = $fs->get_props();
    if($param{CASE_SENSITIVE}){

ȤäͤƻȤƲ


=cut

sub get_props()
{
    my $self = shift;
    my $prop;
    my %return;

    # ñ
    foreach $prop (@props) {
	$return{$prop} = $self->{$prop};
    }
    
    return %return;
}

=item $fs->set_split_text($start_text, $end_text);

get_file_part ؿǥեФݤгϡλ֤򼨤ʸꤷޤ

ͤǡꤵƤƤ (ʸ, λʸ) ֤ޤ

Τ褦ѤƲ

    $fs->set_split_text("", "λ");
    @split_point = ("", "λ");
    $fs->set_split_text(@split_point);

⤷⡢B<FileSplit>  new Ƹ̤Τޤޡ뤤ϼΤ褦

    $fs->set_split_text("", "λ");
    $fs->set_split_text("", undef);

Ȥä褦ˡʸ/̤ͤϤȡ

  ϰ֤ξˤϥեƬ
  λ֤ξˤϥեޤ

Ȱޤ


=cut

sub set_split_text(@)
{
    my $self = shift;
    my @split = (shift, shift);
    my @old_text;

    @old_text = ($self->{SPLIT_TEXT_S},
		 $self->{SPLIT_TEXT_E});

    $self->{SPLIT_TEXT_S} = $split[0];
    $self->{SPLIT_TEXT_E} = $split[1];

    return @old_text;
}

=item $fs->get_split_text();

եФݤгϡλ֤򼨤ʸȤơꤵƤͤޤ

ͤǡꤵƤƤ (ʸ, λʸ) ֤ޤ

    @split_point = $fs->get_split_text();


=cut

sub get_split_text()
{
    my $self = shift;

    return ($self->{SPLIT_TEXT_S}, $self->{SPLIT_TEXT_E});
}

=item $fs->set_file_name($filename);

B<FileSplit> оݤȤե̾ꤷޤ

    $fs->set_file_name("./splitfile.txt");

ͤǡˤϿ͡եΥץ󤬽ʤξˤϵ֤ͤޤ

ϼ̤ꡣ

  δؿꤷե뤬get_file_part() ᥽åɤ
    оݤȤʤޤ 

  ʣƤӽФȡǸͤͭˤʤޤ
    ΤᡢƱ FileSplit Υ֥ȤѤơʣΥե
    Ѥ˺Ѥ뤳ȤǽǤ

  ⤷оݤȤե뤬 euc ʳξˤǽ
    뤿euc Ѵޤ
    Ǥϡjcode.pl μưȽѤƤޤ꤬
    ˤϡset_props() ᥽åɤŪϥ
    Ʋ

  ե̾open ԲĤξˤϡ顼ʵˤȤ
    Τդ뤳ȡ

  ΥåϡλǥեΤŸƤ
    Τǡʥեξˤϡ꤬ȯǽ
     
    (ѥȤʥեоݤȤơ®ͥФä
     )


=cut

sub set_file_name($)
{
    my $self = shift;
    my $text;
    my $split_char;

    # 
    $self->{FNAME} = "";
    $self->{TEXT} = "";

    # HTML ե̾
    my $filename = shift;


    # եΰɤ߹
    open(FILEFANDLE, $filename) || return 0;
    $split_char = $/;
    undef $/;
    $self->{TEXT} = <FILEFANDLE>;
    $/ = $split_char;
    close(FILEFANDLE);

    # ɤ euc Ѵ
    jcode::convert(\($self->{TEXT}), 'euc', $self->{INPUT_CODE}, $self->{INPUT_CONV_OPT});


    # ɤ߹ե̾Ǽ
    $self->{FNAME} = $filename;


    # ʿե̾
    return 1;
}

=item $fs->get_file_name();

C<FileSplit> оݤȤꤵƤե̾Τޤ

    $filename = $fs->get_file_name();

=cut

sub get_file_name()
{
    my $self = shift;

    # HTML ե̾μ
    return $self->{FNAME};
}

=item $fs->get_file_part(var_name => var_val,...);

B<FileSplit> оݤȤꤵƤ뤫顢ʬФԤʤޤ

ͤǡФƥȤ֤ޤ
⤷бвս̵꤬ʤɤξˤϡʸޤ

κݤˡե˴ޤޤʸȤѴΤ̾ͤ򡢥ϥåͤϤƲ
ʸŸɬפʤˤϡڻꤻ˸ƤӽФƲ

ƥȤϡǤ euc ɤǽϤޤ
⤷⡢ϥɤѹϡB<set_props()> ᥽åɤŪϥꤷƲ

ܤˤĤƤϡǽ DESCRIPTION 򻲾ȤƲ


=cut

sub get_file_part(%)
{
    my $self = shift;
    my %argments;
    my $text = "";

    # ѥ᡼Υå
    if ($#_ > 0) {
	%argments = @_;
    }

    # ʬФʤ餽ʬ
    if($self->{SPLIT_TEXT_S} ne "" ||
       $self->{SPLIT_TEXT_E} ne "" ){
	$text = $self->_get_file_part();

    }
    # иĽ꤬ʤʤΤ
    else{
	$text = $self->{TEXT};
    }


    # ѿŸʤŸ
    if(keys(%argments) > 0){
	$self->_replace_file_arg(\$text, \%argments);
    }

    # ɤѥɤѴ
    jcode::convert(\$text, $self->{OUTPUT_CODE}, 'euc', $self->{OUTPUT_CONV_OPT});

    # HTML ֵ
    return $text;
}


#--------------------------------------------
# ե뤫м½
# _get_file_part($) 
#
# 
#  ʤ
#
# ͡
#   Фƥ
#   бвս̵꤬ʤɤξ "" 
#
# 
#  Filerc ⥸塼Υץ饤١
#   ؿǤ
#   
#--------------------------------------------
sub _get_file_part()
{
    my $self = shift;

    my ($text_start, $text_end);
    my $text_out;
    my ($text_s, $text_m, $text_e);

    # оĴ
    #   _S ˻꤬ʤС
    #   _E ˻꤬ʤСʹ
    $text_start = $self->{SPLIT_TEXT_S};
    $text_end = $self->{SPLIT_TEXT_E};
    if ($text_start eq "") {
	$text_start = '^';
    }
    if ($text_end eq "") {
	$text_end = '$';
    }


    # ϰϤ
    #   CASE_SENSITIVE ʤʸʸ⸷̩
    if($self->{CASE_SENSITIVE} != 0){
	$self->{TEXT} =~ /($text_start)(.*)($text_end)/s;
        ($text_s, $text_m, $text_e) = ($1, $2, $3);
    }
    else{
	$self->{TEXT} =~ /($text_start)(.*)($text_end)/is;
        ($text_s, $text_m, $text_e) = ($1, $2, $3);
    }

    # ɤޤफɤǡʬϰϤѹ
    if ($self->{KEYWORD_INC} != 0) {
        $text_out = $text_s . $text_m . $text_e;
    }
    else {
        $text_out .=  $text_m;
    }

    return $text_out;
}

#--------------------------------------------
# եβʸʬŸ
#
# _replace_file_arg($$) 
#
# 
#  ʸŸƥȤؤλ
#  ʸʬλꡣ
#    ѿ̾ͤȹ礻ˤϥåؤλȤꡣ
#
# ͡
#   ʤ
#
# 
#  Filerc ⥸塼Υץ饤١
#   ؿǤ
# ƥ ${hogehoge} ǡǻ
#   줿ΤȰפΤŸ
# Ÿ޻ߤˤ \${hogehoge} 
#   ƥͽꤹ롣
#   ܺ٤ϼΤ褦˹Ԥʤ
#     ${hogehoge} -> Ÿ
#     \${hogehoge} -> ޻
#     \\${hogehoge} -> \ + Ÿ  (\\  \ Ȥư)
#     \\\${hogehoge} -> \ + ޻ (ǽ \\  \,  \ ޻߻Ȥߤʤ)
#     $ ޤʤ \ 1ʸ \ Ȥ롣
#--------------------------------------------
sub _replace_file_arg($$)
{
    my $self = shift;
    my ($p_text, $argtmp) = @_;

    my %argments = %{$argtmp};
    my $key;

    # ѹܤʸ֤Ÿ
    #
    #  ${hogehoge} -> Ÿ
    #  \${hogehoge} -> ޻
    #  \\${hogehoge} -> \ + Ÿ  (\\  \ Ȥư)
    #  \\\${hogehoge} -> \ + ޻ (ǽ \\  \,  \ ޻߻Ȥߤʤ)
    #  $ ޤʤ \ 1ʸ \ Ȥ롣
    #
    #  Ÿˡϡ
    #    1. join ǰ쵤Ÿоݤ OR  (hoge1|hoge2|...|hogeN) Ϥ
    #    2. ʸޤǤϥåơ˱޻ߤб
    #    3. \${} -> ޻, \\$ -> \ + Ÿ, \\\$ -> \ + ޻
    #  ÿȤ롣
    #  ĤɽǵҤ뤳Ȥǡ¿ŤŸ򤷤ʤ褦ˤƤ롣
    #
    #  ɽˤʸ֤ʬιϡ
    #    s[׾]{Ѵ}gex
    #  άǡ줾
    #    [׾] -> (Ǥդ3ʸ)(${(ɤΤ줫OR)})
    #    {Ѵ} -> ν֤бåѴ
    #                  \\\${}, \\${}, \${}, ${}
    #                  黻Ҥǡelseif ŪˤĤʤǤΤǡ˰פ
    #                  1ŸԤʤ롣
    #
    #  CGI.pm  unescapeHTML ֥롼Τ򻲹ͤˤ
    #
    my @key = keys %argments;
    $$p_text =~ s[(.{0,3})(\$\{(${\(join('|', @key))})\})]{
                                      my $pre = $1;
				      my $val = $2;
				      my $arg_name = $3;
				      local $_ = $pre;
				      /\\{3}$/ ? "\\$val" :
				      /(.?)\\\\$/ ? "$1\\$argments{$arg_name}" :
				      /(.{0,2})\\$/ ? "$1$val" :
				      ${pre} . $argments{$arg_name}
			      }gex;
    return 1;

}


1;
__END__

=back

=head1 AUTHOR

Rab-Duck, rabduck@mail.infoseek.co.jp

=head1 SEE ALSO

L<HtmlSplit>

=cut
