package MiniSplit::HtmlSplit;

#
# Copyright 2001, Rab-Duck <rabduck@mail.infoseek.co.jp>
#
# This library is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# 
# Last Update(UTC): $Date: 2001/01/19 16:22:00 $
#

=head1 NAME

MiniSplit::HtmlSplit - Html Splitter Module

=head1 SYNOPSIS

 use MiniSplit::HtmlSplit;
 $hs = new MiniSplit::HtmlSplit;

 # ɤϴޤޤʸʸζ̤򤹤
 $hs->set_props(KEYWORD_INC => 0, CASE_SENSITIVE => 1);

 # оݥե ./text.html 
 $hs->set_file_name("./test.html");

 # н(ʸŸ
 #   TEST ʬ
 $text = $hs->get_file_part("TEST", {var1 => "ʸ1", var2 => "ʸ2"});


=head1 DESCRIPTION

B<MiniSplit::HtmlSplit> 饹ϡPerl 5 Υ⥸塼ǡ

  HTML ե뤫ʬ

  Ф˴ޤޤʸʬѴ

Ȥǽ󶡤ޤ(ʹߡB<MiniSplit::HtmlSplit>  B<HtmlSplit> Ⱦά)

ǤϡʬФΤˡڤФեǼΤ褦 

 <!-- HtmlSplit:???? START -->
 ...
 <!-- HtmlSplit:???? END -->

ȤȤ򵭽Ҥޤ"????" ʬˤϡǤξեǸͭꤹ뤿Υɤꤷޤ(νθˤĤƤϡB<set_file_part> ᥽åɤβˤޤ)

㤨СΤ褦˵Ҥȡ

 
 <!-- HtmlSplit:hogehoge START -->
 ڤФʬ
 <!-- HtmlSplit:hogehoge END -->
 

B<HtmlSplit> ѻˡ B<get_file_part> ᥽åɤ "hogehoge" ꤹȡб START  END ֤вǽǤ

ʬ̤ʸ (<!-- HtmlSplit  -->) ϡB<set_split_text()> ᥽åɤѹǽǤ

ʸʬˤĤƤ B<FileSplit> εǽѤƤơƱ褦 ${hogehoge} η HTML ˻ꤷѹƤ B<HtmlSplit> ѻ˻ꤷޤβʸʬξܤܺ٤ϡL<FileSplit> λͽ򻲹ͤˤƲ


εǽˤĤƤϡźդΥץ뤬ܤΤǡ򻲾ȤƲ

ޤB<HtmlSplit>  B<FileSplit> Υץ֥饹ǡ᥽åɤѾƤޤ
B<HtmlSplit> Ѥˤ⡢B<set_props(), get_props(), get_file_name()> Ѥ뤳ȤꤷƤޤΤǡˤĤƤ L<FileSplit> 򻲾ȤƲ

=head1 Methods


B<HtmlSplit> ϡΤ褦ʥ᥽åɤޤ

=over 4

=cut

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

use MiniSplit::FileSplit;

@ISA = qw(MiniSplit::FileSplit);

$VERSION = '1.00';

# ؿ
sub HTML_PART_KEY_LOOSE(){'[ \t]*<!--\s*HtmlSplit\s*:'}
sub HTML_PART_START_LOOSE(){'\s+START\s*-->[ \t]*\n?'}
sub HTML_PART_END_LOOSE(){'\s+END\s*-->[ \t]*\n?'}

=item $hs = new MiniSplit::FileSplit;

B<HtmlSplit> ο֥Ȥޤ

ȤơB<set_props()> ᥽åɤƱƤϤư򤹤뤳ȤǽǤ


=cut

sub new
{
    # 饹֥̾ȤλȤ
    my $class = shift;
    my $self = new MiniSplit::FileSplit;

    # bless
    bless($self, $class);

    $self->{HTML_SPLIT_COMHEAD} = HTML_PART_KEY_LOOSE;
    $self->{HTML_SPLIT_START} = HTML_PART_START_LOOSE;
    $self->{HTML_SPLIT_END} = HTML_PART_END_LOOSE;

    # ѥ᡼СԤʤ
    if ($#_ > 0) {
	$self->SUPER::set_props(@_);
    }
    
    return $self;
}

=item $hs->set_split_text($com_text, $start_text, $end_text);

B<get_file_part()> ᥽åɤǥեФݤгϡλ֤Ƚ̤륭ɤޤʸꤷޤ

$com_text ˤϳϽλʬ̤Ⱦʬ$start_text, $end_text ˤϤ줾졢/λ˸ͭθȾʬ(ƱƤ)ꤷޤ
λˤϡɽλǽǤ

㤨С

  $fs->set_split_text("<!-- Split:", " S -->", " E -->");

ȻꤹˤϡHTML եǡ

  <!-- Split:hogehoge S -->
  Фʬ
  <!-- Split:hogehoge E -->

ȵҤޤ

⤷⡢Τ褦

    $fs->set_split_text("ʬ", "", "λ");
    $fs->set_split_text("ʬ", "", undef);

Ȥä褦ˡʸʤ/̤ͤ򡢳/λθͭʬϤȡ

  ϰ֤ξˤϥեƬ
  λ֤ξˤϥեޤ

Ȱޤ

ͤǡꤵƤ֤ͤޤ(¤ӤϰƱ)

ͤϡ

  ʬ:'[ \t]*<!--\s*HtmlSplit\s*:'
  ϸͭ:'\s+START\s*-->[ \t]*\n?'
  λͭ:'\s+END\s*-->[ \t]*\n?'

ȤƤޤ

ǤνˤϡHTML ƥ \r\n βԥɤ \n ѴƤޤB<set_split_text()> ǤΥѥˤϡԥɤ \n ѤƲ


=cut

sub set_split_text(@)
{
    my $self = shift;
    my ($split_com_head, $split_start, $split_end) = @_;
    my @old_text;

    @old_text = ($self->{HTML_SPLIT_COMHEAD},
		 $self->{HTML_SPLIT_START},
		 $self->{HTML_SPLIT_END});

    $self->{HTML_SPLIT_COMHEAD} = $split_com_head;
    $self->{HTML_SPLIT_START} = $split_start;
    $self->{HTML_SPLIT_END} = $split_end;

    return @old_text;
}

=item $hs->get_split_text($com_text, $start_text, $end_text);

get_file_part() ᥽åɤǥեФݤгϡλ֤Ƚ̤륭ɤޤʸȤơꤵƤͤޤ

ͤǡꤵƤƤ (ʬ, ϸͭ, λͭ) ֤ޤ

    @split_point = $hs->get_split_text();


=cut

sub get_split_text()
{
    my $self = shift;

    return  ($self->{HTML_SPLIT_COMHEAD},
	     $self->{HTML_SPLIT_START},
	     $self->{HTML_SPLIT_END});
}

=item $hs->set_file_name($filename);

B<HtmlSplit> оݤȤե̾ꤷޤ

    $hs->set_file_name("./splitfile.txt");

ͤǡˤϿ͡եΥץ󤬽ʤξˤϵ֤ͤޤ

ǤνѤˡHTML ƥ \r\n βԥɤ \n ˡ B<set_file_name()> ѴƤޤB<set_split_text()> ǤΥѥʤɡԥɤ \n ѤƲ

¾ˤĤƤϡƥ饹Ǥ L<FileSplit>  B<set_file_name()> ᥽åɤ򻲾ȤƲ

=cut

sub set_file_name($)
{
    my $self = shift;
    my $return;

    # ƤΥ᥽åɤƤӽФ
    $return = $self->SUPER::set_file_name(@_);

    unless ($return) {
	return $return;
    }

    # Ԥ \r\n  \n Ѵ
    $self->{TEXT} =~ s/\r\n/\n/g;

    return 1;
}


=item $fs->get_file_part($split_pos, {var_name => var_val,...});

B<HtmlSplit> оݤȤꤵƤե뤫顢ʬФԤʤޤ

ͤǡФƥȤ֤ޤ
⤷бвս̵꤬ʤɤξˤϡʸޤ

 $split_pos ˤвսб륭ɤꤷޤ⤷줬̤/ʸξ硢եΤоݤȤޤ

 {var_name => var_val, ...} ˤϡե˴ޤޤʸȤѴΤ̾ͤ򡢥ͤΥڥȤꤷϥåͤλȤϤƲʸŸɬפʤˤϡΰꤷʤ/ΥϥåͤϤƲ

ƥȤϡǤ euc ɤǽϤޤ
⤷⡢ϥɤѹϡB<set_props()> ᥽åɤŪϥꤷƲ

B<set_props()>  OUTPUT_CODE  'sjis' ˤƤƤˤϡԥɤ\n  \r\n ˤƽϤƤޤ(ƥ饹 FileSplit  get_file_part() ǤѴƤޤ󤬡HtmlSplit ϤѴ򤷤ޤ)


ܤˤĤƤϡǽ DESCRIPTION 򻲾ȤƲ


=cut

sub get_file_part($$)
{
    my $self = shift;
    my ($part_name, $p_argments) = @_;
    my $htmltext = "";
    my ($split_start, $split_end);

    if ($part_name ne "") {
	if ($self->{HTML_SPLIT_START} ne "") {
	    $split_start = $self->{HTML_SPLIT_COMHEAD} . $part_name . $self->{HTML_SPLIT_START};
	}
	if ($self->{HTML_SPLIT_END} ne "") {
	    $split_end = $self->{HTML_SPLIT_COMHEAD} . $part_name . $self->{HTML_SPLIT_END};
	}
    }

    $self->SUPER::set_split_text($split_start, $split_end);
    
    $htmltext = $self->SUPER::get_file_part(%{$p_argments});

    if ($self->{OUTPUT_CODE} eq 'sjis') {
	$htmltext =~ s/([^\r])\n/\1\r\n/g;
    }

    return $htmltext;
}

=back

=head1 AUTHOR

Rab-Duck, rabduck@mail.infoseek.co.jp

=head1 SEE ALSO

L<FileSplit>

=cut
